/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/

//
//	DateUtility
//	変更履歴
//		2004.02.01	新規作成
//

package jp.co.ntt.lms.lo.scorm.util;

import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.StringTokenizer;

import jp.co.ntt.lms.lo.scorm.kernel.exception.SystemException;

/**
 *  DateUtility<BR>
 *  DateUtilityクラス<BR>
 */
public class DateUtility {

	/** タイムゾーン文字列までの区切り数(区切り文字も含む) */
	final static int COUNT_TOKEN_FOR_TIME_ZONE = 11;

	/** タイムゾーン文字列の長さ */
	final static int TIME_ZONE_LENGTH = 5;

	/** タイムゾーンの国コード文字列の長さ */
	final static int TIME_ZONE_COUNTRY_LENGTH = 2;

	/** タイムゾーンの時間文字列の長さ */
	final static int TIME_ZONE_TIME_LENGTH = 2;

	/** dateTimeの区切り文字 */
	final static String DATE_TIME_DELIM = "-:+T";

	/**
	 *
	 *	任意のdateTime文字列をCalendar型に変換する
	 *
	 * @param	dateTime	Calendar型に変換したい文字列
	 *						書式：yyyy-MM-ddThh:mm:ss.sss±xx:tt
	 *								yyyy:西暦
	 *								MM:月
	 *								dd:日
	 *								T:年月日と時間の区切り。T以下は時間
	 *								hh:時
	 *								mm:分
	 *								ss.sss:秒
	 *								±:タイムゾーンの符号。+か-
	 *								xx:タイムゾーンの国コード
	 *								tt:タイムゾーンの時差時間
	 *								タイムゾーン部分はなくても可
	 *
	 * @return 	入力パラメータをCalendar型に変換した変数
	 *
	 */
	public static Calendar toCalendar(String dateTime) throws SystemException {

		try {
			if (dateTime == null || dateTime.equals("")) {
				return null;
			}

			Calendar ss = Calendar.getInstance();
			SimpleDateFormat formatter = null;
			StringBuffer set_time = null;

			// 入力パラメータを区切り文字で分割
			StringTokenizer st = new StringTokenizer(dateTime, DATE_TIME_DELIM, true);
			if (st == null || st.countTokens() < COUNT_TOKEN_FOR_TIME_ZONE) {
				throw new SystemException("DateTime[toCalendar]: '" + dateTime + "' の書式エラーです。");
			}

			if (st.countTokens() > COUNT_TOKEN_FOR_TIME_ZONE) {
				// タイムゾーン部直前までの文字列を取得
				set_time = new StringBuffer(st.nextToken());
				for (int i = 1; i < COUNT_TOKEN_FOR_TIME_ZONE; i++) {
					set_time.append(st.nextToken());
				}

				// タイムゾーンの取得
				set_time.append(st.nextToken());
				if (st.hasMoreTokens()) {
					set_time.append(st.nextToken());
				}
				else {
					throw new SystemException("DateTime[toCalendar]: '" + dateTime + "' の書式エラーです。");
				}

				if (st.hasMoreTokens()) {
					// 国コードと時間の間に「:」がある時は取り除く
					st.nextToken();
					set_time.append(st.nextToken());
				}

				formatter = new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss.SSSZ");
			}
			else { // 入力パラメータにタイムゾーン部分がない時
				set_time = new StringBuffer(dateTime);
				formatter = new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss.SSS");
			}

			ss.setTime(formatter.parse(set_time.toString()));

			return ss;

		}
		catch (Exception e) {
			throw new SystemException("DateTime[toCalendar()]:'" + dateTime + "' をCalendar型に変換出来ません。", e);
		}
	}

	/**
	 *
	 *	任意のCalendar型変数をString型に変換する
	 *
	 * @param	ss	String型に変換したいCalendar型変数
	 * @return	入力パラメータをString型に変換した変数
	 * 				書式：yyyy-MM-ddThh:mm:ss.sss±xx:tt
	 *								yyyy:西暦
	 *								MM:月
	 *								dd:日
	 *								T:年月日と時間の区切り。T以下は時間
	 *								hh:時
	 *								mm:分
	 *								ss.sss:秒
	 *								±:タイムゾーンの符号。+か-
	 *								xx:タイムゾーンの国コード
	 *								tt:タイムゾーンの時差時間
	 *
	 */

	public static String toString(Calendar ss) throws SystemException {

		try {
			if (ss == null) {
				return ("");
			}

			// 入力パラメータを文字列に変換
			SimpleDateFormat formatter = new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss.SSSZ");
			String time_str = formatter.format(ss.getTime());

			// 変換した文字列を区切り文字で分割
			StringTokenizer st = new StringTokenizer(time_str, DATE_TIME_DELIM, true);
			StringBuffer set_time = null;

			// タイムゾーン部分の編集
			if (st.countTokens() > COUNT_TOKEN_FOR_TIME_ZONE) {
				// タイムゾーン部直前までの文字列を取得
				set_time = new StringBuffer(st.nextToken());
				for (int i = 0; i < COUNT_TOKEN_FOR_TIME_ZONE; i++) {
					set_time.append(st.nextToken());
				}

				// タイムゾーン文字列の国コードと時間の間に「:」を入れる
				String time_zone = st.nextToken();
				set_time.append(time_zone.substring(0, time_zone.length() - TIME_ZONE_TIME_LENGTH));
				set_time.append(":");
				set_time.append(time_zone.substring(time_zone.length() - TIME_ZONE_TIME_LENGTH));
				return (set_time.toString());
			}
			else {
				// 入力パラメータにタイムゾーン部分がない時は変換した文字列をそのまま返す
				return time_str;
			}

		}
		catch (Exception e) {
			throw new SystemException("DateTime[toString()]: 指定されたCalendar型変数を文字列に変換出来ません。", e);
		}

	}
}
